/**
 * File for struct logic.
 */


// User Import Headers.
#ifndef user_headers
    #define user_headers
    #include "structs.h"
#endif


// Global Variables.
const int TYPE_DIR = 0;
const int TYPE_FILE = 1;
const int TYPE_OTHER = 2;
path_validator_struct* path_validator_ptr;


/**
 * Initializes a "path_validator" object.
 */
path_validator_struct* initialize_path_validator_struct(int file_type, std::error_code err_code) {

    // printf("\n");
    // printf("initialize_path_validator_struct:\n");
    // printf("    file_type: %i\n", file_type);
    // if (err_code) {
    //     std::cerr << "    err_code: " << err_code.message();
    // } else {
    //     printf("    err_code: null\n");
    // }
    // printf("\n");

    // Create struct.
    path_validator_ptr = (path_validator_struct*) calloc(1, sizeof(path_validator_struct));

    // Populate fields.
    path_validator_ptr->file_type = file_type;
    path_validator_ptr->err_code = err_code;

    return path_validator_ptr;
}


/**
 * Destroyes passed "path_validator" object and all associated fields.
 */
void free_path_validator_struct(path_validator_struct* path_validator_ptr) {
    free(path_validator_ptr);
}

